;;; -*- lexical-binding: t -*-

(require 'psession)

(defvar my-big-list
  (mapcar (lambda (n)
            (mapcar (lambda (m)
                      (let ((s (format "hello-%d-%d" m n)))
                        (list m n s (intern s))))
                    (number-sequence 1 100)))
            (number-sequence 1 1000)))

(push '(my-big-list . "my-big-list.el")
      psession-object-to-save-alist)

(defun bench ()
  (garbage-collect)
  (let* ((gcs0 gcs-done)
         (gc-elapsed0 gc-elapsed)
         (t0 (float-time))
         (_result (psession--dump-object-to-file-save-alist))
         (dt (- (float-time) t0))
         (gcs (- gcs-done gcs0))
         (gc-time (- gc-elapsed gc-elapsed0)))
    (message "%.3f s elapsed, %d GCs, %.3f s in GC, %.3f s non-GC"
             dt gcs gc-time (- dt gc-time))))

(bench)
